SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!Tests methodsFor: 'Something' stamp: 'PabloRago 6/19/2013 20:58'!
abstractDetector

	^ AbstractDetector new.
	
"can understand, 
hay que devolver las clases concretas, las hojas
las clases intermedias pueden implementar el mtodo abstracto "! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/21/2013 19:44'!
test00AbstractDetectorShouldRaiseErrorWithNonExistingMethod
	
	|abstractDetector|
	
	abstractDetector := self abstractDetector.
	
	self should: [ 
		abstractDetector isAbstract: #nonExistingMehod in: ClassWithAbstractMethod
		]
	raise: Error 
	withExceptionDo: [ :anError | self assert: (anError description = ('Error: ',AbstractDetector nonExistingMethodMessage)) ].! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/21/2013 19:44'!
test01AbstractDetectorShouldReturnIfMethodClassIsAbstract

	|abstractDetector|

	abstractDetector := self abstractDetector.
	self assert: (abstractDetector isAbstract: #abstractMethod in: ClassWithAbstractMethod).
	
	self deny: (abstractDetector isAbstract: #instanceMethod in: ClassWithAbstractMethod).
	 ! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'MartinCarreiro 6/21/2013 20:09'!
test02AbstractDetectorShouldReturnEmptyWhenAllConcreteSubclassesUnderstandsAbstractMethod

	|abstractDetector classesThatNotImplementAbstractMethod|

	abstractDetector := self abstractDetector.
	classesThatNotImplementAbstractMethod := abstractDetector subclassesNotImplementingAbstractMethod: #abstractMethod for: ClassWithAbstractMethodComplete.
	self assert: (classesThatNotImplementAbstractMethod isEmpty).
	 ! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/19/2013 21:21'!
test03AbstractDetectorShouldReturnTheConcreteSubclassesThatCantUnderstandTheAbstractMethod

	abstractDetector := self abstractDetector.
	 ! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/19/2013 21:20'!
test04AbstractDetectorShouldReturnOnlyConcreteSubclassesThatCantUnderstandTheAbstractMethod
	 ! !

!Tests methodsFor: 'Abstract DetectorTests' stamp: 'PabloRago 6/21/2013 20:20'!
testXXAbstractDetectorShouldReturnEmptyWhenAllConcreteSubclassesUnderstandsAbstractMethod

	|abstractDetector classesThatNotImplementAbstractMethod|

	abstractDetector := self abstractDetector.
	classesThatNotImplementAbstractMethod := abstractDetector subclassesNotImplementingAbstractMethod: #abstractMethod for: ClassWithAbstractMethod.
	self assert: (classesThatNotImplementAbstractMethod size = 2).
	 ! !

Object subclass: #AbstractDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractDetector class methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 20:07'!
nonExistingMethodMessage

	^'Clase no contiene este mensaje'.! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/21/2013 20:13'!
boo: message for: class 
	
	| nonImplementingSubclasses  |
	
		nonImplementingSubclasses := Set new.
				
				class subclassesDo: [ :aSubclass | 
					(self class: aSubclass implements: message) ifTrue:[
							 (self isAbstract: message in: aSubclass) ifTrue: [ 
									(aSubclass subclasses isEmpty) ifTrue: [ 
											nonImplementingSubclasses add: aSubclass. 
										 ] ifFalse:[
											"recursive call"
											nonImplementingSubclasses addAll: (self recursiveSubclassesNotImplementingAbstractMethod: message for: aSubclass ).
									].
							].
					] ifFalse: [
							(aSubclass subclasses isEmpty) ifTrue: [ 
 											"^Set with: aSubclass."
											nonImplementingSubclasses add: aSubclass. 
										 ] ifFalse:[
											"recursive call"
											nonImplementingSubclasses addAll: (self recursiveSubclassesNotImplementingAbstractMethod: message for: aSubclass ).
									].
					].
				].
			
		^nonImplementingSubclasses.! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/21/2013 19:23'!
class: aClass implements: aMessage
	
	^aClass methodDict includesKey: aMessage.
	! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:14'!
compiledMethod: message from: class 
	
	[^class methodDict at: message.]
		on: Error
		do: [ Error signal: 'Clase no contiene este mensaje' ].
	! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/21/2013 19:44'!
isAbstract: message in: class 
	
	|method|
	
	method := self compiledMethod: message from: class.
	^method isAbstract .
	! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/21/2013 19:48'!
isConcreteClass: aClass
	 ^ aClass subclasses isEmpty.! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/21/2013 20:19'!
recursiveSubclassesNotImplementingAbstractMethod: message for: class 
	
	| nonImplementingSubclasses  |
	
		nonImplementingSubclasses := Set new.
				
				class subclassesDo: [ :aSubclass | 
					
					(((self class: aSubclass implements: message) not) or: [ (self isAbstract: message in: aSubclass) ] ) ifTrue: [ 
								(aSubclass subclasses isEmpty) ifTrue: [ 
										nonImplementingSubclasses add: aSubclass. 
								 ] ifFalse:[
										"recursive call"
										nonImplementingSubclasses addAll: (self recursiveSubclassesNotImplementingAbstractMethod: message for: aSubclass ).
								].
						 ].
				].
			
		^nonImplementingSubclasses.! !

!AbstractDetector methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/21/2013 19:46'!
subclassesNotImplementingAbstractMethod: message for: class 
	
	
	(self isAbstract: message in: class)
		ifTrue:[ 
			^ self recursiveSubclassesNotImplementingAbstractMethod: message for: class.
		] ifFalse: [ 
			^Set new.
		]! !

Object subclass: #ClassWithAbstractMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassWithAbstractMethod subclass: #ClassImplementingAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstract subclass: #Class1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstract subclass: #Class2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassImplementingAbstract methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 19:58'!
abstractMethod
 	
	^1.! !

ClassWithAbstractMethod subclass: #ClassNotImplementingAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassNotImplementingAbstract subclass: #ClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassNotImplementingAbstract subclass: #ClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassNotImplementingAbstract subclass: #ClassCImplements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassCImplements methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:24'!
abstractMethod 
	 
	^1.! !

!ClassWithAbstractMethod methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 19:58'!
abstractMethod
  
	^ self subclassResponsibility.! !

!ClassWithAbstractMethod methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 21:18'!
instanceMethod
  
	^ 1.! !

Object subclass: #ClassWithAbstractMethodComplete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassWithAbstractMethodComplete subclass: #ClassImplementingAbstractA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstractA subclass: #Class1A
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstractA subclass: #Class2A
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassImplementingAbstractA methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/21/2013 19:06'!
abstractMethod
  
	^ 1.! !

ClassWithAbstractMethodComplete subclass: #ClassImplementingAbstractB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstractB subclass: #Class1B
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClassImplementingAbstractB subclass: #Class2B
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassImplementingAbstractB methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/21/2013 19:06'!
abstractMethod
  
	^ 2.! !

!ClassWithAbstractMethodComplete methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 6/21/2013 19:05'!
abstractMethod
  
	^ self subclassResponsibility.! !

Object subclass: #ClassWithOutAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClassWithOutAbstract methodsFor: 'as yet unclassified' stamp: 'PabloRago 6/19/2013 19:58'!
method

	^1.! !
